$input = shift;
$num_clusters = shift;
$max = shift;

$total_obj = 0; $total_diam_have = 0; $total_diam_save = 0;
@obj = (); @diam_have = (); @diam_save = ();
@have = (); @save = ();

for(my $i = 0; $i < $max; $i++) {
  system "diametrical -i $input -num_clusters $num_clusters > out";
  open (OUT, "out");
  while(<OUT>) {
    if ($_ =~ /Objective/) {
      chomp $_;
      @temp = split(/\s/, $_);
      $total_obj += $temp[3];
      $obj[$i] = $temp[3];
    }
   if ($_ =~ /Diametric/) {
      chomp $_;
      @temp = split(/\s+/, $_);
      $total_diam_have += $temp[3];
      $diam_have[$i] = $temp[3];
      $total_diam_save += $temp[6];
      $diam_save[$i] = $temp[6];
    }
   if ($_ =~ /Separated/) {
      chomp $_;
      @temp = split(/\s+/, $_);
      $total_have += $temp[3];
      $have[$i] = $temp[3];
      $total_save += $temp[6];
      $save[$i] = $temp[6];
      #print $save[$i] . "\n";
    }
  }
}

$avg_obj = $total_obj/$max;
$avg_have = $total_have/$max;
$avg_save = $total_save/$max;
$avg_diam_have = $total_diam_have/$max;
$avg_diam_save = $total_diam_save/$max;

$total_obj = 0;
$total_have = 0;
$total_save = 0;
$total_diam_have = 0;
$total_diam_save = 0;

for(my $i = 0; $i < $max; $i++) {
  $total_obj += ($avg_obj - $obj[$i])*($avg_obj - $obj[$i]);
  $total_have += ($avg_have - $have[$i])*($avg_have - $have[$i]);
  $total_save += ($avg_save - $save[$i])*($avg_save - $save[$i]);
  $total_diam_have += ($avg_diam_have - $diam_have[$i])*($avg_diam_have - $diam_have[$i]);
  $total_diam_save += ($avg_diam_save - $diam_save[$i])*($avg_diam_save - $diam_save[$i]);
}

$var = $total_obj/($max-1);
$diam_have_var =  sqrt($total_diam_have/($max-1));
$diam_save_var =  sqrt($total_diam_save/($max-1));
$have_var =  sqrt($total_have/($max-1));
$save_var =  sqrt($total_save/($max-1));

$dev = sqrt($var);
print "Objective : Mean = $avg_obj, Variance = $var, Std. Dev. = $dev\n";
print "Diametric Have : Mean = $avg_diam_have, Dev = $diam_have_var\n";
print "Diametric Save : Mean = $avg_diam_save, Dev = $diam_save_var\n";
print "Have : Mean = $avg_have, Dev = $have_var\n";
print "Save : Mean = $avg_save, Dev = $save_var\n";


