// $Id: options.h,v 1.2 1997/11/24 19:38:59 huson Exp $
//
// Program options
//
// Daniel Huson, 10.97

#pragma once
#include<LEDA/string.h>
#include<LEDA/stream.h>

class tOptions
{
 public:
  tOptions(void);
  ~tOptions();
  
  void parse_command_line(int argc,const char *argv[]);
  
  void usage(void) const;
  
  void report(void) const;
  
  int verbose;
  
  string infile;
  string outfile;
  
  istream &ins(void) const;
  istream &ins2(void) const;
  ostream &outs(void) const;
  ostream &outs2(void) const;
  ostream &outs3(void) const;
  
  int num_clusters;
  int t1;
  double t2;
  int normalize;
  
  int simulate;
  int columns;
  double noise;
  int compare_function;
  int random_cluster;
  int permute;

  int do_data;
  int init_clusters_out;

	string init_clusters; 

  ostream *outsp2;
  ostream *outsp3;

 private:
  istream *insp;
  istream *insp2;
  ostream *outsp;
  
};

// EOF
